//+------------------------------------------------------------------+
//|                                                trendlinesDay.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "nsi2000"
#property link      "http://www.expert-mt4.nm.ru"
//----
#property indicator_chart_window
//---- input parameters
extern ENUM_TIMEFRAMES TimeFrame=PERIOD_CURRENT;
extern int nPeriod=10;
extern int Limit=350;
extern string UniqueID = "AutoTL1";
extern color color1 = Red;
extern color color2 = Magenta;
extern color color3 = Blue;
extern color color4 = Aqua;
///---- int Widners Oscilator
int cnt,nCurBar=0;
string indicatorFileName;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- Output in Char
   indicatorFileName = WindowExpertName();
   TimeFrame=MathMax(TimeFrame,_Period);
   for(cnt=0; cnt<=5; cnt++)
     {
      ObjectCreate(UniqueID+"WSO-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet(UniqueID+"WSO-"+cnt,OBJPROP_COLOR,color1);
      if(cnt<5)
        {
         ObjectCreate(UniqueID+"Trend DN-"+cnt,OBJ_TREND,0,0,0,0,0);
         ObjectSet(UniqueID+"Trend DN-"+cnt,OBJPROP_COLOR,color2);
        }
      //----
      ObjectCreate(UniqueID+"WRO-"+cnt,OBJ_HLINE,0,0,0);
      ObjectSet(UniqueID+"WRO-"+cnt,OBJPROP_COLOR,color3);
      if(cnt<5)
        {
         ObjectCreate(UniqueID+"Trend UP-"+cnt,OBJ_TREND,0,0,0,0,0);
         ObjectSet(UniqueID+"Trend UP-"+cnt,OBJPROP_COLOR,color4);
        }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   for(cnt=0; cnt<=5; cnt++)
     {
      ObjectDelete(UniqueID+"Trend UP-"+cnt);
      ObjectDelete(UniqueID+"Trend DN-"+cnt);
      ObjectDelete(UniqueID+"WSO-"+cnt);
      ObjectDelete(UniqueID+"WRO-"+cnt);
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if (TimeFrame!=_Period) { double dummy=iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,nPeriod,Limit,UniqueID,color1,color2,color3,color4,0,0); return(0); }
//---- TODO: add your code here
   double r1,r2,r3,r4,r5,r6;
   int rt1,rt2,rt3,rt4,rt5,rt6;
   double s1,s2,s3,s4,s5,s6;
   int st1,st2,st3,st4,st5,st6;
//----    
   if(Bars<Limit) Limit=Bars-nPeriod;
   for(nCurBar=Limit; nCurBar>0; nCurBar--)
     {
      if(Low[nCurBar+(nPeriod-1)/2]==Low[Lowest(NULL,0,MODE_LOW,nPeriod,nCurBar)])
        {
         s6=s5; s5=s4; s4=s3; s3=s2; s2=s1; s1=Low[nCurBar+(nPeriod-1)/2];
         st6=st5; st5=st4; st4=st3; st3=st2; st2=st1; st1=nCurBar+(nPeriod-1)/2;
        }
      if(High[nCurBar+(nPeriod-1)/2]==High[Highest(NULL,0,MODE_HIGH,nPeriod,nCurBar)])
        {
         r6=r5; r5=r4; r4=r3; r3=r2; r2=r1; r1=High[nCurBar+(nPeriod-1)/2];
         rt6=rt5; rt5=rt4; rt4=rt3; rt3=rt2; rt2=rt1; rt1=nCurBar+(nPeriod-1)/2;
        }
     }
//---- Move Object in Chart

   ObjectMove(UniqueID+"Trend DN-0",1,Time[st1],s1);
   ObjectMove(UniqueID+"Trend DN-0",0,Time[st2],s2);
//----
   ObjectMove(UniqueID+"Trend UP-0",1,Time[rt1],r1);
   ObjectMove(UniqueID+"Trend UP-0",0,Time[rt2],r2);
//----
   return(0);
  }
//+------------------------------------------------------------------+